/// <reference types="node" />
import { ExecOptions, DebugLogger, ExtraSpawnOptions } from "builder-util";
import { SpawnOptions } from "child_process";
export declare function parseVmList(debugLogger: DebugLogger): Promise<ParallelsVm[]>;
export declare class VmManager {
    exec(file: string, args: Array<string>, options?: ExecOptions): Promise<string>;
    spawn(command: string, args: Array<string>, options?: SpawnOptions, extraOptions?: ExtraSpawnOptions): Promise<any>;
    toVmFile(file: string): string;
}
export declare class ParallelsVmManager extends VmManager {
    private readonly vm;
    private startPromise;
    private isExitHookAdded;
    constructor(vm: ParallelsVm);
    exec(file: string, args: Array<string>, options?: ExecOptions): Promise<string>;
    spawn(command: string, args: Array<string>, options?: SpawnOptions, extraOptions?: ExtraSpawnOptions): Promise<any>;
    private doStartVm();
    private ensureThatVmStarted();
    toVmFile(file: string): string;
}
export declare function macPathToParallelsWindows(file: string): string;
export interface ParallelsVm {
    id: string;
    os: "win-10" | "ubuntu" | "elementary";
}
